<?php

    /*

    ThePirateBay Lite update script v0.1.1
    Copyright (C) 2005  Buzzard/Zero1

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    */



    // Todo... One day... When I don't have anything better to do :-)
    //
    //   - Add some sort of error checking :)
    //   - Make sure its XHTML compliant
    //   - Change torrentDetails into a associative array
    //   - Switch to the template system I wrote for my bookmarks script
    //   - use PREG_SET_ORDER for the main regex rather than re-arranging the
    //     array myself :-)   [I didn't know about the flag when I wrote it]



    set_time_limit( 0 );
    require( "Snoopy.class.php" );


    $torrents   =   array();
    $html       =   "";


    ////////////////////////////////////////////////////////////////////////////
    // Grab the pages and parse them for details ///////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    for( $i = 0; $i <= 15; $i++ )
    {
        echo "Grabbing page $i...\n";

        $torrentsTemp = getTorrentDetailsFromFile( "http://www.thepiratebay.org/torrents-search.php?cat=0&page=$i" );
        $torrents = array_merge( $torrents, $torrentsTemp );

        // Lets be nice to the server :-)
        sleep( 5 );
    }

    $torrents = runPostProcessingOnTorrentDetails( $torrents );
    $torrents = sortTorrentDetails( $torrents );



    ////////////////////////////////////////////////////////////////////////////
    // Loops throught he array and create the html /////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    printHtmlHeader();


    $currentCat = "NULL";

    foreach( $torrents as $torrent )
    {

        // If the current torrent has a different caterogry from the last
        // print a new header
        if( $torrent[0] != $currentCat )
        {
            $currentCat = $torrent[0];
            printHtmlRowHeader( $currentCat );
        }

        printHtmlRow( $torrent );
    }

    printHtmlFooter();

    if( file_exists( "data/index_raw.html" ) )
        unlink( "data/index_raw.html" );

    file_put_contents2( "data/index_raw.html", $html );



    // The next 4 Function should be self explantory :-)
    function printHtmlHeader()
    {
        global $html;

        $html .= "<html>\n";
        $html .= "  <head>\n";
        $html .= "    <link href='style.css' rel='stylesheet' type='text/css'>\n";
        $html .= "    <title>ThePirateBay Lite  v0.1.1</title>\n";
        $html .= "  </head>\n";
        $html .= "  <body>\n";
        $html .= "    <h1 align='center' style='margin: 0'>ThePirateBay Lite</h1>\n";
        $html .= "    <div align='center' style='font-size: 80%;'>A low bandwith version of <a href='http://www.thepiratebay.org'>ThePirateBay.org</a></div>\n";
        $html .= "    <br/>\n";
        $html .= "    <table class='maintable' cellpadding='4' cellspacing='0' align='center'>\n";
    }


    function printHtmlFooter()
    {
        global $html;

        $html .= "    </table>\n";
        $html .= "  <br/><br/>\n";
        $html .= "  <div align='center' style='font-size: 80%'>\n";
        $html .= "    ThePirateBayLite written by Buzzard/Zero1.  Source available from <a href='http://project-2501.net/'>project-2501.net</a><br/>\n";
        $html .= "    Page generated on " . date( "l dS of F Y \\a\\t h:i:s A" ) . "\n";
        $html .= "  </div>\n";
        $html .= "  </body>\n";
        $html .= "</html>\n";
    }


    function printHtmlRowHeader( $category )
    {
        global $html;

        $html .= "      <tr class='header1'><td colspan='5'>$category</td></tr>\n";
        $html .= "      <tr class='header2'>\n";
        $html .= "        <td class='torrent_left'>Date</td>\n";
        $html .= "        <td>Torrent Name</td>\n";
        $html .= "        <td>Size (# Files)</td>\n";
        $html .= "        <td>Seeds</td>\n";
        $html .= "        <td class='torrent_right' >Leachers</td>\n";
        $html .= "      </tr>\n";
    }


    // This one is slightly more complicated, check the comments in the following function
    // to find out what each index is for
    function printHtmlRow( $torrentDetails )
    {
        global $html;

        $html .= "      <tr>\n";
        $html .= "        <td class='torrent_left'>{$torrentDetails[6]}</td>\n";
        $html .= "        <td><a href='{$torrentDetails[1]}'><b>[I]</b></a> <a href='{$torrentDetails[3]}'>{$torrentDetails[2]}</a></td>\n";
        $html .= "        <td>{$torrentDetails[8]} ({$torrentDetails[4]})</td>\n";
        $html .= "        <td align='center'>{$torrentDetails[10]}</td>\n";
        $html .= "        <td class='torrent_right' align='center'>{$torrentDetails[11]}</td>\n";
        $html .= "      </tr>\n";
    }



    // A snoopy class wrapper function... Grab the page and pretend to be a
    // real user :)
    function snoppyHttpGet( $url )
    {
        $snoopy = new Snoopy;

        $snoopy->agent      = "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)";
        $snoopy->referer    = "http://www.google.com/";

        if( $snoopy->fetch( $url ) )    return $snoopy->results;
        else                            return false;
    }



    // This function (which is almost all the work is in one regex), grabs a file
    // and extracts a list of all the torrents and their details into an array
    function getTorrentDetailsFromFile( $filename )
    {

        // Try and grab the requested URL, if something went wrong (ie. $html
        // === false) then wait 5 seconds and try again.... For some reason
        // socket errors are common
        $html = snoppyHttpGet( $filename );

        if( $html === false )
        {
            // Try again
            sleep( 5 );
            $html = snoppyHttpGet( $filename );

            if( $html === false )
                return false;
        }


        // This function does pretty much all the work :D
        //
        // Edit:
        //   Wow there is around a *massive* increase in speed by changing the start from "/.+?"  to  "/.*?"
        //   No idea why... Looks like I still have plently to learn about regexs  :)
        $num_matches = preg_match_all( "/.*?\\/categories\\/(.+?).gif.+?<a href=\"(.+?)&amp.+?<b>(.+?)<\\/b>.+?<a href=\"(.+?)\".+?filelist=1\">(.+?)<\\/a>.+?<font size=1 face=Verdana>(.+?)<\\/td>.+?<font size=1 face=Verdana>(.+?)<br \\/>(.+?)<\\/td>.+?<font size=1 face=Verdana>(.+?)<\\/td>.+?<font size=1 face=Verdana>(.+?) g&.+?<font size=1 face=Verdana>.+?>(.+?)<.+?<font size=1 face=Verdana>.+?>(.+?)</s", $html, $matches );



        // The matches array contains all the data but in the wrong way
        // $matches["detailes"]["row"] and with offsets starting at one
        // So we post-process [ :-) ] the array re-organising the data
        for( $j = 0; $j < ($num_matches); $j++ )            // For the 13 torrents (sometimes 12 WTF?... page 1 and 2 contain 13, but 3 and 4 contain 12)
            for( $i = 1; $i <= 12; $i++ )                   // tweleve categories
                $torrentDetails[$j][] = $matches[$i][$j];   // Use a [] instead of [$i] as $i starts at 1 not 0


        // Structure details:
        //
        //   torrentDetails[0] =>
        //   {
        //     [0] => Category
        //     [1] => details URL
        //     [2] => torrent name
        //     [3] => download url
        //     [4] => Number of files in .torrent
        //     [5] => Number of comments (NOT USED)
        //     [6] => Date (year-month-day)
        //     [7] => Time (hour-minu-sec)
        //     [8] => Size (string)
        //     [9] => No Idea :)
        //     [10] => Seeds
        //     [11] => Leachers
        //   }
        //   etc.

        return $torrentDetails;
    }




    // Due to the html layout, some torrent vars still contain html
    // this function cleans up a torrent details array
    function runPostProcessingOnTorrentDetails( $torrentDetails )
    {

        $origCatNames   = array( "windows", "linux", "mac", "audioBooks",  "anime", "apps",         "dvdr", "filmklipp",   "games", "misc", "movies", "music", "Musicvid",     "pics",     "tv",       "spel.annat", "comics", "xbox",       "gamecube",       "books", "barn", "ps2",                 "pr0n" );
        $newCatNames    = array( "Windows", "Linux", "Mac", "Audio Books", "Anime", "Applications", "DVDR", "Video Clips", "Games", "Misc", "Movies", "Music", "Music Videos", "Pictures", "TV Shows", "???",        "Comics", "Xbox Games", "Gamecube Games", "Books", "Barn", "Playstation 2 Games", "pr0n" );

        for( $i = 0; $i < count( $torrentDetails ); $i++ )
        {
            // Slightly change the catergory names
            $torrentDetails[$i][0] = str_replace( $origCatNames, $newCatNames, $torrentDetails[$i][0] );

            // [11] (num leachers or seeds?) often looks like this:  <a class="green" href="torrents-details.php?id=3288787&amp;hit=1&amp;todlers=1">15
            // rather than just a number so we have to strip the html away
            if( strpos( $torrentDetails[$i][11], "green" ) !== false )
                $torrentDetails[$i][11] = substr( $torrentDetails[$i][11], strrpos( $torrentDetails[$i][11], ">" )+1 );

            // add http://www.thepiratebay.org/ to the start of the torrent details url
            $torrentDetails[$i][1] = "http://www.thepiratebay.org/" . $torrentDetails[$i][1];

            // add http://www.thepiratebay.org/ to the start of the download url
            $torrentDetails[$i][3] = "http://www.thepiratebay.org/" . $torrentDetails[$i][3];

            // We don't want torrent names that are two long
            $torrentDetails[$i][2] = shortStr( $torrentDetails[$i][2], 60 );

        }

        return $torrentDetails;
    }


    // Sort the torrent details, first by cat, then by torrentname
    function sortTorrentDetails( $torrentDetails )
    {
        // sortTorrentDetails_compare is the custom sort functino below
        usort($torrentDetails, "sortTorrentDetails_compare");
        return $torrentDetails;
    }


    // Custom function for asort(), used by the sortTorrentDetails() function
    // I know that this could really be optimised, however it only needs to sort
    // under 400 strings, and only every 6 hours and its much cleaner written
    // like this.
    function sortTorrentDetails_compare( $a, $b )
    {
        $val1 = strnatcasecmp( $a[0], $b[0] );  // Category
        $val2 = strnatcasecmp( $b[6], $a[6] );  // Date.  $a and $b are reverse here so we sort in descending order not ascending
        $val3 = strnatcasecmp( $a[2], $b[2] );  // Torrent Name

        // We want the torrents to be sorted by category, then date, then name


        if( $val1 == 0 )        // Are the categories the same?
        {
            if( $val2 == 0 )    // Is the date the same?
            {
                return $val3;   // Then sort using the torrent name
            }
            else
            {
                return $val2;   // Then sort using the date
            }
        }
        else
        {
            return $val1;       // Then sort using the Category
        }
    }


    // Trims a string, to a certain length and appends '...' to it (yes its buggy :-))
    function shortStr( $str, $length = 60 )
    {
        if( $length < 3 ) return $str;                          // Don't do anything, invalid length
        else if( strlen( $str ) <= $length) return $str;        // If its right on the limit, don't do anything
        else return substr( $str, 0, ($length-3) ) . "...";
    }


    // Wish my host used PHP5 :-(
    // The if function exists function wasn't working so its now called this :-)
    function file_put_contents2( $filename, $dataStr )
    {
        if( ($fOut = fopen( $filename, "w" )) === false )
            return false;

        if( ($bytesWritten = fwrite( $fOut, $dataStr )) === false )
            return false;

        fclose($fOut);

        return $bytesWritten;
    }

?>